#include "common.h"
#include "commands.h"
#include "str.h"
#include "strfuncs.h"
#include "ostream.h"

#include "sieve.h"

bool cmd_capability(struct client_command_context *cmd)
{
	struct client *client = cmd->client;
	const char *sievecap, *notifycap;

	o_stream_cork(client->output);

	T_BEGIN {
		/* Get capabilities */
		sievecap = sieve_get_capabilities(NULL);
		notifycap = sieve_get_capabilities("notify");


		/* Default capabilities */
  		client_send_line(client, t_strconcat("\"IMPLEMENTATION\" \"", 
			managesieve_implementation_string, "\"", NULL));
		client_send_line(client, t_strconcat("\"SIEVE\" \"", 
			( sievecap == NULL ? "" : sievecap ), "\"", NULL));

		/* Notify methods */
		if ( notifycap != NULL ) {
			client_send_line(client, t_strconcat("\"NOTIFY\" \"", 
				notifycap, "\"", NULL));
		}

		/* Natively supported extensions */
		client_send_line(client, "\"RENAME\"");
		client_send_line(client, "\"NOOP\"");

		/* Finish */
		client_send_line(client, "OK \"Capability completed.\"");
	} T_END;

	o_stream_uncork(client->output);

	return TRUE;

}

